﻿/****************************
* Assembly.as 
* extends the MovieClip
****************************/
class Assembly extends MovieClip {
	private var myPlayer:Player;
	private var myAssemblyNum:Number;
	private var myRoot:MovieClip;
	private var gameboardInstance;
	public var pointDot:MovieClip;
	//nested MC
	public var assNum:MovieClip;
	//nested MC
	private var myRotation:Number;
	private var waitingItem:Item;
	private var waitingToShowItem:Item;
	private var itemsOnAssembly:Array;
	private var stopper:Number;	
	/*****
					* Constructor
		*****/
	public function Assembly() {
		gameboardInstance = Gameboard.getInstance();
		itemsOnAssembly = new Array();
		//stopper = -1;
		stopper = 9999;
	}
	public function getPoint() {
		return pointDot;
	}
	public function getX() {
		return this._x;
	}
	public function getY() {
		return this._y;
	}
	public function getRotation() {
		return this.myRotation;
	}
	public function getMyAssemblyNum() {
		return myAssemblyNum;
	}
	public function getStopper(){
		//trace("GetStopper = "+stopper+" on ASSEMBLY = "+myAssemblyNum);
		return stopper;
		}
	public function setStopper(stopFrame:Number){
		trace("SET STOPPER to: "+stopFrame+" on ASSEMBLY = "+myAssemblyNum);
		stopper = stopFrame;
		}
	/*****
		* Initilisation of player's items
		* Adding the Assembly object
		* Attaching Movie Clip to Assembly
		*****/
	public function init(playerObj:Player, x:Number, y:Number, r:Number):Void {
		//trace("ASSEMBLY init: x"+x+" y "+y+" r "+r);
		myRoot = Game.getRoot();
		myPlayer = playerObj;
		myAssemblyNum = myPlayer.getPlayerNum();
		this.assNum.text = myAssemblyNum;
		this._x = x;
		this._y = y;
		myRotation = r;
		this._rotation = myRotation;
		waitingItem = null;
		waitingToShowItem = null;
		pointDot._visible = false;
		//		iconNum = Math.round(Math.random()*9+1);
		//this.gotoAndPlay("i_"+iconNum);
		//	tableInstance.addCardToTable(this);
	}
	public function addToWaitingForPickUp(item:Item) {
		waitingItem = item;
	}
	public function removeFromWaitingForPickUp(item:Item) {
		deleteFromItemsOnAssembly(item);
		waitingItem = null;
	}
	public function getWaitingObj() {
		return waitingItem;
	}
	public function addToWaitingToShow(item:Item) {
		waitingToShowItem = item;
	}
	public function removeFromWaitingToShow(item:Item) {
		waitingToShowItem = null;
	}
	public function getWaitingToShowItem() {
		return waitingToShowItem;
	}
	public function addToItemsOnAssembly(item:Item) {
		//trace("**********ADD TO ITEMS ON ASSEMBLY * LINE "+myAssemblyNum+"** ITEM: "+item);
		
		itemsOnAssembly.push(item);
	//	trace("itemsOnAssembly"+myAssemblyNum+" = "+itemsOnAssembly);
		checkForNearItems();
	}
	public function deleteFromItemsOnAssembly(item:Item) {
		//trace("**********DELETE FROM ITEMS ON ASSEMBLY * LINE "+myAssemblyNum+"** ITEM: "+item);
		for (var i = 0; i<itemsOnAssembly.length; i++) {
			if (itemsOnAssembly[i] == item) {
				itemsOnAssembly[i] = null;
			}
		}
		//trace("itemsOnAssembly = "+ itemsOnAssembly);
	}
	public function checkForNearItems():Void {
		//return;//for testing
		//trace("******* function checkForNearItems **********");
		for (var i = 0; i<itemsOnAssembly.length; i++) {
			if (itemsOnAssembly[i] == null){
				//trace("skipping null");
				continue;
			}
			if (itemsOnAssembly[i].getIsStopped() == true){
				continue;
				}
			var curFrame = itemsOnAssembly[i]._currentframe;
			//trace("current frame = "+curFrame);
			for (var j = i+1; j<itemsOnAssembly.length; j++) {
				if (itemsOnAssembly[j] == null){
					continue;
				}
				var nextObjFrame = itemsOnAssembly[j]._currentframe;
				//trace("Comparing "+curFrame+" with "+nextObjFrame);
				if (Math.abs(curFrame-nextObjFrame)<=7) {
					//trace("############### Need to push");
					if(curFrame>nextObjFrame){
						//push curFrame item
						itemsOnAssembly[i].gotoAndPlay(curFrame+7);
						//trace("curFrame PUSHED");
					}else {
						//push nextObjFrame item	
						itemsOnAssembly[j].gotoAndPlay(nextObjFrame+7);
						//trace("nextObjFrame PUSHED");
					}
						
				}
			}
		}
	}
	public function killMovieClip() {
		removeMovieClip(this);
	}
}
