﻿/*
 * Avatar.as
 * generic Avatar class, for loading and manipulating Avatars
 * every Avatar created should subscribe to either DPadEmulator or TouchscreenEmulator for player control
 */

class Avatar {
	private static var BASE_DEPTH:Number = 50000;	//avatars are attached from this depth
	
	private var root:MovieClip;			//reference to root timeline
	private var pNum:Number;			//player number (0-3)
	private var mc:MovieClip;			//avatar movieclip
	
	private var speed:Number = 10;		//avatar movement speed
	
	public function Avatar (_r:MovieClip, _pNum:Number, symbolID:String) {
		root = _r;
		pNum = _pNum;
		
		root.dpEm.addDPadListener(this, pNum);
		
		initMC(symbolID);
	}
	
	private function initMC (symbolID:String) :Void {
		mc = root.attachMovie(symbolID, "avatar"+pNum, Avatar.BASE_DEPTH+pNum);
		
		if (pNum==0) {
			mc._x = Stage.width/2;
			mc._y = Stage.height - 15;
		} else if (pNum==1) {
			mc._x = 10;
			mc._y = Stage.height/2;
		} else if (pNum==2) {
			mc._x = Stage.width/2;
			mc._y = 15;
		} else if (pNum==3) {
			mc._x = Stage.width - 10;
			mc._y = Stage.height/2;
		}
	}
	
	public function onControlPressed (cCode:String) :Void {
		if (cCode == "U") { mc._y -= speed; }
		else if (cCode == "D") { mc._y += speed; }
		else if (cCode == "L") { mc._x -= speed; }
		else if (cCode == "R") { mc._x += speed; }
		else if (cCode == "A") { trace("Avatar "+pNum+" pressed 'A'"); }
		else if (cCode == "B") { trace("Avatar "+pNum+" pressed 'B'"); }
	}
	
	public function onControlReleased (cCode:String) :Void {
		if (cCode == "U") { trace("Avatar "+pNum+" released 'U'"); }
		else if (cCode == "D") { trace("Avatar "+pNum+" released 'D'"); }
		else if (cCode == "L") { trace("Avatar "+pNum+" released 'L'"); }
		else if (cCode == "R") { trace("Avatar "+pNum+" released 'R'"); }
		else if (cCode == "A") { trace("Avatar "+pNum+" released 'A'"); }
		else if (cCode == "B") { trace("Avatar "+pNum+" released 'B'"); }
	}
}
