﻿/****************************
* Game.as 
* The main class for the Build a Toy game
* Initiates the Players
* Initiates the Assembly Lines - each assembly line corresponds to a player
* Starts the overall game timer

****************************/
class Game implements MyTimerListener {
	private static var dpem:DPadEmulator = null;
	private static var player0Instance:Player;
	private static var player1Instance:Player;
	private static var player2Instance:Player;
	private static var player3Instance:Player;
	private static var root:MovieClip;
	
	private static var gameboardInstance:Gameboard;
	private static var INIT_NUM_OF_PARTS:Number = 10;
	private static var assembly0Instance:Assembly;
	private static var assembly1Instance:Assembly;
	private static var assembly2Instance:Assembly;
	private static var assembly3Instance:Assembly;
	private var t:Timer = null;
	private static var GAME_TIME:Number;
	private static var TIME_TICK:Number;
	private static var gameTimeLeft:Number;
	/*****
		* Constructor
		*****/
	public function Game() {
	}
	/*****
		* Entry point
		*****/
	public static function main(_r:MovieClip):Void {
//		trace("Starting application.");
		GAME_TIME = 60000;
		TIME_TICK = 1000;
		gameTimeLeft = GAME_TIME;
		var playerNum:Number;
		var mcZ:Number;
		var mcName:String;
		root = _r;
		gameboardInstance = Gameboard.getInstance(GAME_TIME);
		
		
		//PLAYER 0
		playerNum = 0;
		mcZ = 1000+playerNum;
		mcName = "player_"+playerNum;
		var o = root.attachMovie("player_mc", mcName, mcZ+5);
		player0Instance = Player(o);
		//init textBoxes
		var textBox = root.text_mc_0;
		player0Instance.init(160, 225, 0, playerNum, textBox);
		//x,y,rotation, playerNum
		var o = root.attachMovie("assembly", "assembly_0", mcZ);
		assembly0Instance = Assembly(o);
		assembly0Instance.init(player0Instance, 55, 224, 0);
		gameboardInstance.createAssemblyLine(assembly0Instance);

		
		//PLAYER 1
		playerNum = 1;
		mcZ = 1000+playerNum;
		mcName = "player_"+playerNum;
		var o = root.attachMovie("player_mc", mcName, mcZ+5);
		player1Instance = Player(o);
				//init textBoxes
		var textBox = root.text_mc_1;		
		//player1Instance.init(275, 120, -90, playerNum, textBox);
		player1Instance.init(45, 120, 90, playerNum, textBox);
		var o = root.attachMovie("assembly", "assembly_1", mcZ);
		assembly1Instance = Assembly(o);
		
		//assembly1Instance.init(player1Instance, 265, 224, -90);
		assembly1Instance.init(player1Instance, 55, 15, 90);
		gameboardInstance.createAssemblyLine(assembly1Instance);

		
		
		//PLAYER 2
		playerNum = 2;
		mcZ = 1000+playerNum;
		mcName = "player_"+playerNum;
		var o = root.attachMovie("player_mc", mcName, mcZ+5);
		player2Instance = Player(o);
						//init textBoxes
		var textBox = root.text_mc_2;
		player2Instance.init(160, 15, 180, playerNum, textBox);
		var o = root.attachMovie("assembly", "assembly_2", mcZ);
		assembly2Instance = Assembly(o);
		assembly2Instance.init(player2Instance, 265, 15, 180);
		gameboardInstance.createAssemblyLine(assembly2Instance);

		
		
		//PLAYER 3;
		playerNum = 3;
		mcZ = 1000+playerNum;
		mcName = "player_"+playerNum;
		var o = root.attachMovie("player_mc", mcName, mcZ+5);
		player3Instance = Player(o);
						//init textBoxes
		var textBox = root.text_mc_3;
		//player3Instance.init(45, 120, 90, playerNum, textBox);
		player3Instance.init(275, 120, -90, playerNum, textBox);
		var o = root.attachMovie("assembly", "assembly_3", mcZ);
		assembly3Instance = Assembly(o);
		assembly3Instance.init(player3Instance, 265, 224, -90);
		//assembly3Instance.init(player3Instance, 55, 15, 90);
		gameboardInstance.createAssemblyLine(assembly3Instance);

		
		
		/////////////////////////////////////////
		
		gameboardInstance.initDepositCenter();
		var g:Game = new Game();
		g.startGame();
		gameboardInstance.startTimer();		
	}
	/****
		Initiates overall game timer
	******/
	public function startGame():Void{
		startTimer();
		
	}
	
	/**
		* Creates a new instance of DPAdEmulator if necessary and returns it
		**/
	public static function getDpem():DPadEmulator {
		if (dpem == null) {
			dpem = DPadEmulator.getInst(root);
		}
		return dpem;
	}
	/************** GETTERS *****************/
	/*****
		*Getter for root
		*Returns root
		*****/
	public static function getRoot():MovieClip {
		return root;
	}
	
	/************* END OF GETTERS *******************/
	
		/*****
		* Starts timer
		*****/
		private function startTimer() {
		/*if (this.t != null) {
							//TODO: change timer, so it loads only once, and then resets each time we need it
							//kill old timer
							this.t.killTime();
						}*/
//		this.t = new Timer(this, -1, GAME_TIME);
		this.t = new Timer(this, GAME_TIME, TIME_TICK);
		
		this.t.startTime();
	}
	
	public function toString():String { 
		return "Object Class: Game";
	
	}
		
	public function calcGameTimeLeft(){
		gameTimeLeft = gameTimeLeft - TIME_TICK;
		gameboardInstance.drawTimeLeft(gameTimeLeft);
		}
	/******* MyTimerListener Interface implementation *******/
	/*****
		*
	*****/
	public function timerTick(t:Timer):Void {
		//trace ("timer tick");
		calcGameTimeLeft();

		
	}
	/*****
						* when timeOver, gets new main card
				*****/
	public function timeOver(t:Timer):Void {
		//trace("timeOver");
		gameboardInstance.gameOver();
		//		initItem();
	}
}
