﻿/****************************
* Player.as 
* Player class for the Build a Toy game
* Represents the player
* Resposible for letting Gameboard know player's actions
* Extands MovieClip
****************************/
class Player extends MovieClip {
	private var myRoot:MovieClip;
	private var playerNum:Number;
	public var player:MovieClip;
	//nested MC it has takenToyPart mc
	public var playerWalk:MovieClip;//nested MC - has walk cycle
	private var gameboardInstance;
	private var playerStatus:Number;
	//0 - not holding obj, 1 - holding obj., 2 - holding his own object
	private var playerMoving:Boolean;
	private var myTxtBoxMC:MovieClip;
	private var toyPartInHands:Item;
	private var numCollectedItems:Number;
	private var MAX_NUM_ITEMS_TO_COLLECT:Number;
	/*****
							* Constructor
					*****/
	public function Player() {
		//trace("an instance of class Player was constructed");
		myRoot = Game.getRoot();
		gameboardInstance = Gameboard.getInstance();
		playerStatus = 0;
		playerMoving = false;
		numCollectedItems = 0;
		MAX_NUM_ITEMS_TO_COLLECT = 3;
		//number of item each player needs to collect to build the best toy
	}
	/************** GETTERS *****************/
	/*****
								*Getter for playerNum
								*Returns Player's number
								*****/
	public function getPlayerNum():Number {
		return playerNum;
	}
	/*****
					/************** END OF GETTERS *****************/
	/*****
					* Initilisation of player mc
					*****/
	public function init(x:Number, y:Number, rotation:Number, playerN:Number, txt:MovieClip):Void {
		//trace ("Positioning player");
		this._x = x;
		this._y = y;
		this._rotation = rotation;
		playerNum = playerN;
		myTxtBoxMC = txt;
		player.gotoAndPlay("player_"+playerNum);
		player.takenToyPart._visible = false;
		Game.getDpem().addDPadListener(this, playerNum);
	}
	public function getNumCollectedItems() {
		return numCollectedItems;
	}
	public function onControlPressed(code) {
		switch (code) {
		case "L" :
		trace("player "+playerNum+" Left");
			if (playerMoving == false) {
				
				this.gotoAndPlay("left");
				this.player.playerWalk.gotoAndPlay("walk");
				playerMoving = true;
			}
			break;
		case "R" :
		trace("player "+playerNum+" Right");
		if (playerMoving == false) {

				this.gotoAndPlay("right");
				this.player.playerWalk.gotoAndPlay("walk");
				playerMoving = true;
			}
			break;
		case "U" :
		trace("player "+playerNum+" Up");
			if (playerMoving == false) {
				
				if (playerStatus == 2 && numCollectedItems<MAX_NUM_ITEMS_TO_COLLECT) {
					trace("Ready to deposit");
					this.gotoAndPlay("up");
					this.player.playerWalk.gotoAndPlay("walk");
				} else if (playerStatus == 0) {
					this.gotoAndPlay("up");
					this.player.playerWalk.gotoAndPlay("walk");
					//myTxtBoxMC.gotoAndPlay("start");
					//myTxtBoxMC.msg_txt.text = "Nothing to deposit";
				} else if (playerStatus == 1) {
					//			trace ("my text box ="+myTxtBoxMC);
					this.gotoAndPlay("up");
					this.player.playerWalk.gotoAndPlay("walk");
					//myTxtBoxMC.gotoAndPlay("start");
					//myTxtBoxMC.msg_txt.text = "Wrong part";
				} else {
					//this happens when player already collected the needed number of items
					//TODO: decide maybe we should not show the items of that type, once
					//the player collected the needed amount
					myTxtBoxMC.gotoAndPlay("start");
					myTxtBoxMC.msg_txt.text = "You've got all parts";
				}
				playerMoving = true;
			}
			break;
		}
	}
	public function onControlReleased(code) {
		//trace("Released: player "+num);
		//velX = 0;
	}
	public function touchedAssemblyLine(side:String) {
		trace("touched assembly line: side = "+side);
		//1. check if there is item to get
		//2. if yes - get the item
		//3. walk to center
		switch (side) {
		case "left" :
			//check if player got object
			var waitingPart = gameboardInstance.checkForToyPart(this);
			//show object in player's hands
			if (waitingPart != null && playerStatus == 0) {
				var toyType = waitingPart.getMyType();
				player.takenToyPart._visible = true;
				player.takenToyPart.gotoAndPlay("type_"+toyType+"_1");
				gameboardInstance.playerTookItem(this, waitingPart);
				//player, toyPart
				//trace ("Taken toy is of type: "+toyType);
				if (playerNum == toyType) {
					trace("Player num"+playerNum+"Taken toy is of type: "+toyType);
					playerStatus = 2;
				} else {
					playerStatus = 1;
				}
				toyPartInHands = waitingPart;
			}
			this.gotoAndPlay("leftBack");
			break;
		case "right" :
			//check if player is hodling object
			if (playerStatus == 1 || playerStatus == 2) {
				var waitingToShowPart = gameboardInstance.checkForWaitingToShowPart(this);
				//trace ("watingToShowPart ="+waitingToShowPart);
				gameboardInstance.playerPassedItem(this, waitingToShowPart);
			}
			// put object on assembly line
			playerStatus = 0;
			this.gotoAndPlay("rightBack");
			//hide object in player's hands
			player.takenToyPart._visible = false;
			break;
		case "up" :
			if (playerStatus == 2 && numCollectedItems<MAX_NUM_ITEMS_TO_COLLECT) {
				//Player deposited item
				numCollectedItems++;
				gameboardInstance.playerDepositedItem(this, toyPartInHands);
				player.takenToyPart._visible = false;
				playerStatus = 0;
				if (numCollectedItems == MAX_NUM_ITEMS_TO_COLLECT){
					gameboardInstance.addToItemsTypeCollected(playerNum);
					}
			} else if (playerStatus == 0) {
				myTxtBoxMC.gotoAndPlay("start");
				myTxtBoxMC.msg_txt.text = "Nothing to deposit";
			} else if (playerStatus == 1) {
				myTxtBoxMC.gotoAndPlay("start");
				myTxtBoxMC.msg_txt.text = "Wrong part";
			}
			this.gotoAndPlay("upBack");
			break;
		default :
			trace("error - no such side");
			break;
		}
	}
	public function playerNotMoving(){
		trace ("function playerNotMoving");
		this.player.playerWalk.gotoAndPlay("stand");
		playerMoving = false;
	}
}
