﻿/****************************
* Deck.as 
* Deck class for the cards game
* Represents player's deck - cards that are closed
* Responsible for letting the player know how many cards in a deck left

****************************/
class Deck {
	private var myPlayer:Player;
	private var initCardsInHands:Number;
	private var totalCards:Number;
	private var tableInstance;
	private var myRoot:MovieClip;
	private var playerNum:Number;
	private var decPosX:Number;
	private var decPosY:Number;
	private var deckOffsetX:Number;
	private var deckOffsetY:Number;
	private var cardsInDeck:Array;
	private var deckTxt:MovieClip; //nested MC
	private var curSlideCard:Card;
	private var cardBackRotation1:Number;
	private var cardBackRotation2:Number;
	private var cardBackRotation3:Number;
	private var cardBackRotation4:Number;

	/*****
					* Constructor
		*****/
	function Deck(x:Number, y:Number, offX:Number, offY:Number) {
		//trace("deck constructor");
		tableInstance = Table.getInstance();
		decPosX = x;
		decPosY = y;
		deckOffsetX = offX;
		deckOffsetY = offY;
		cardsInDeck = new Array();
		cardBackRotation1 = 0;
		cardBackRotation2 = -90;
		cardBackRotation3 = 180;
		cardBackRotation4 = 90;
		
	}
	/************** GETTERS *****************/
	/*****
		/************** END OF GETTERS *****************/
	/*****
		* Initilisation of player's deck
		* Adding the Deck object
		*****/
	public function init(initCards:Number, player:Player):Void {
		//trace("an instance of class Deck was constructed");
		myRoot = Game.getRoot();
		myPlayer = player;
		initCardsInHands = initCards;
		totalCards = initCardsInHands;
		initCardsInDeck();
	}
	/*****
		* Attaching Movie Clips to Deck
		*****/
	public function initCardsInDeck() {
		//trace ("I have " + initCardsInHands + " cards in my hand");
		var mcZ:Number = 100;
		var mcName:String;
		var i:Number;
		var cardBack:MovieClip;
		playerNum = myPlayer.getPlayerNum();
		for (i=0; i<initCardsInHands; i++) {
			//trace(" drawing cards backs");
			mcZ = playerNum*100+i;
			mcName = "cardBack_mc_"+mcZ;
			cardBack = myRoot.attachMovie("deck", mcName, mcZ);
			cardBack._x = decPosX+(i*deckOffsetX);
			cardBack._y = decPosY+(i*deckOffsetY);
			switch (playerNum) {
			case 1 :
				cardBack._rotation = cardBackRotation1;
				break;
			case 2 :
				cardBack._rotation = cardBackRotation2;
				break;
			case 3 :
				cardBack._rotation = cardBackRotation3;
				break;
			case 4 :
				cardBack._rotation = cardBackRotation4;
				break;
			}
			cardBack.cardBack.gotoAndPlay("i_"+playerNum);
			cardBack.deckTxt.cardsTotal.text = i + 1;
			cardsInDeck.push(cardBack);
			cardBack.myDeck = this;
			//trace ("deck = "+ cardBack.myDeck);
		}
		//cardBack.deckTxt.cardsTotal.text = totalCards;
	}
	public function slideCard(cardO:Card) {
		trace ("sliding card::::::::::::::::::::::");
		trace ("slid_"+cardO.getCardNum());
		curSlideCard = cardO;
		var slide = "slide_"+cardO.getCardNum();
		cardsInDeck[cardsInDeck.length-1].gotoAndPlay(slide);
	}
	public function finishedSlide() {
		//trace ("function finishedSlide");
		//curSlideCard.slideDone();
		myPlayer.newCardSlideDone(curSlideCard);
		//			trace ("here we'll subtract card");
		removeMovieClip(cardsInDeck.pop());
	}
	/*****
		* Subtracts a card from player's deck
		*****/
	public function subtractCard(playersCard:Card) {
		trace ("function subtractCard");
		if (totalCards == 0) {
			//no more cards in deck
			tableInstance.setNewCardsReady(true);
			return false;
		}
		slideCard(playersCard);
		totalCards--;
		//cardsInDeck[cardsInDeck.length - 1].deckTxt.cardsTotal.text = totalCards;
		
		// hides text field if there are only two open cards on the table
		if (totalCards == 0) {
			deckTxt._visible = false;
			tableInstance.setNewCardsReady(true);
			// we need to set this flag to true, because new cards are the once left on the table
		}
		return true;
	}
}
