﻿/****************************
* MainCard.as 
* MainCard class for the cards game
* Represents the main card in the center of the "table"
* Extends MovieClip
****************************/
class MainCard extends MovieClip implements MyTimerListener {
	private var cardNum:Number;
	private var cardX:Number;
	private var cardY:Number;
	private var iconNum:Number;
	private var xScaleSpeed:Number;
	private var t:Timer;
	private var degree:Number;
	private var lastRotation:Boolean;
	private var tableInstance:Table;
	private var match:MovieClip; //nested MC
	/*****
		* Constructor
	*****/
	function MainCard() {
		//trace ("main card constructor");
		tableInstance = Table.getInstance();
	}
	/*****
		* Initialises Main card
		* sets 1st icon
		* sets x and y pos
	*****/
	public function init(myIconNum:Number, x:Number, y:Number):Void {
		//trace("an instance of class Main Card was constructed");
		//trace("x ="+x);
		//trace("y ="+y);
		degree = 0;
		iconNum = myIconNum;
		cardX = x;
		cardY = y;
		this._x = cardX;
		this._y = cardY;
		this.match._visible = false;
		//this.gotoAndPlay("i_"+iconNum);
		//show bg
		this.gotoAndPlay("bg");
		reDrawInit(iconNum);
	}
	
	public function matchAnimMain(){
		trace ("function matchAnim main");
		this.match._visible = true;
		this.match.gotoAndPlay("matchAnim_main");
		}
		
	public function matchAnimMainDone(){
		trace ("function match anim done");
		this.match._visible = false;
		//show bg
		this.gotoAndPlay("bg");
		tableInstance.setStatus(5);
		tableInstance.matchAnimFlag = false;
		}
	/*****
		* Redraws Main card
		* changes main card's icon
	*****/
		public function reDrawInit(myIconNum:Number):Void {
		degree = 180;
		xScaleSpeed = - 10;
		//set status in Table to busy = 2
		 tableInstance.setStatus(2);
		// start timer
		this.t = new Timer(this, -1, 25);
		// setting Table as timer's listener
		this.t.startTime();
		
		iconNum = myIconNum;
/*		var lab:String = "i_"+iconNum;
		this.gotoAndPlay(lab);*/
	}
	
	public function reDraw(myIconNum:Number):Void {
		degree = 360;
		xScaleSpeed = - 10;
		// start timer
		lastRotation = false;
		//set status in Table to busy = 2
		 tableInstance.setStatus(2);
		this.t = new Timer(this, -1, 25);
		// setting Table as timer's listener
		this.t.startTime();
		
		iconNum = myIconNum;
/*		var lab:String = "i_"+iconNum;
		this.gotoAndPlay(lab);*/
	}
	public function changeToBg(){
		//show bg
		this.gotoAndPlay("bg");
		}
	
	public function changeIcon(){
		var lab:String = "i_"+iconNum;
		this.gotoAndPlay(lab);
		}
	/******* MyTimerListener Interface implementation *******/
	/*****
				*
		*****/
	public function timerTick(t:Timer):Void {
		// animation
	//trace("MainCard animating");
		if (degree == 180){
	//trace("Animation degree = 180");
		this._xscale += this.xScaleSpeed;
		if (this._xscale <= 5 && this.xScaleSpeed < 0){
			this.xScaleSpeed = + 10;
			
			changeIcon();
			}
		if (this._xscale >= 95 && this.xScaleSpeed > 0){
			this._xscale = 100;
			t.killTime();
			degree = 0;
		//set status in Table to open = 0
		 tableInstance.setStatus(0);
			}
		}
		if (degree == 360){
	//trace("Animation degree = 360");
		this._xscale += this.xScaleSpeed;

		if (this._xscale <= 5 && this.xScaleSpeed < 0 && lastRotation == false){
			this.xScaleSpeed = + 10;
			//changeIcon();
			this.changeToBg();
			}
		if (this._xscale >= 95 && this.xScaleSpeed > 0 && lastRotation == false){
			this._xscale = 100;
			this.xScaleSpeed = - 10;
			lastRotation = true;
		}
			
		if (this._xscale <= 5 && this.xScaleSpeed < 0 && lastRotation == true> 0){
			this.xScaleSpeed = + 10;
			
			changeIcon();
			}
		if (this._xscale >= 95 && this.xScaleSpeed > 0 && lastRotation == true){
			this._xscale = 100;
			t.killTime();
			degree = 0;
		//set status in Table to open = 0
		 tableInstance.setStatus(0);
			}
		}
	}
	/*****
				* when timeOver, gets new main card
		*****/
	public function timeOver(t:Timer):Void {
		//trace("period is over");
		
	}
}
