﻿/**
* Class Gun - represents the gun movieclip
**/

class Gun extends MovieClip implements AnimationTickerListener{
	private var shootingDeg =0; // the degree at which the gun will shoot
	private var turningDeg=0; // the degree to which the gun will turn (more than 360)
	private var turnSpeed = 0; // speed of the turn
	private var curRotation:Number; // current rotation
	private var b:Ball; // Ball object
	private var turningTimerId; // ID of the timer for rotation animation
	
	public var gun_top;
	public var gun_bottom;
//	public var cannon_i;
	
	

	/**
	* Initializes the gun MC and positions it at the center.
	* Arguments:
	* root - parent MC
	**/
	
	public function init(root:MovieClip):Void {
		//this._x = root._width/2;
		//this._y = root._height/2;
		this._x = 320/2 + (this._width/2);
		this._y = 240/2 - (this._height/2);

	}
	
	public function setBallPos(posBall:MovieClip){
//		trace ("Function setBallPos x= "+posBallX+" y = "+posBallY );
		
			var point:Object = {x:posBall._width/2, y:posBall._height/2};
			posBall.localToGlobal(point);
			trace("LOCAL TO GLOBAL RESULT:"+point.x+","+point.y);
			prepareToShoot(point.x, point.y);
			// replace with disappearing animation
			//this._visible = false;
			this.gotoAndPlay("hide");
		}

		
	public function prepareToShoot(bX:Number, bY:Number){
		this.b._x = bX;
		this.b._y = bY - this.b._height/2;
		this.b._visible = true;
		this.b.shoot(this.shootingDeg);
		//this.b.shoot(0);
		}
	/**
	* Prepares the rotation data and starts the animation
	* Arguments:
	* ball - Ball object
	**/
	public function shoot(ball:Ball):Void{
		b=ball;
		curRotation = 0;
		turningDeg = Math.round(Math.random()*1080+720);
		shootingDeg = turningDeg % 360;
		
		turnSpeed = 20;
		AnimationTicker.getInstance().addListener(this);
		
	}

	/**
	* Animation tick. This function is called by the animation timer repeatedly with the 
	* specified interval. It rotates the cannon - and if teh rotation is finished, initiates
	* the ball movement. 
	**/
	
	public function animTick():Void{
		this.curRotation += this.turnSpeed;
		if (this.curRotation > this.turningDeg) {
			this.gun_top._rotation=this.turningDeg;
			this.gun_top.gotoAndPlay("shoot");
			AnimationTicker.getInstance().removeListener(this);
			
			//this.b.shoot(this.shootingDeg);
			//this.b._visible = true;
			// replace with disappearing animation
			//this._visible = false;
		}
		else {
			this.gun_top._rotation = this.curRotation;
			this.turnSpeed -=0.2;
			if (this.turnSpeed <3){ this.turnSpeed=3;}
			updateAfterEvent();
		}
			
		
	}
	
	
}