﻿/*
 * TouchscreenEmulator.as
 * translates mouse drags to touchscreen resolution
 */

class TouchscreenEmulator {
	private static var inst:TouchscreenEmulator;	//Singleton instance
	private var root:MovieClip;						//reference to root timeline
	
	private var RES_X:Number = 10;				//pixel width of a touchscreen column
	private var RES_Y:Number = 10;				//pixel height of a touchscreen row
	private var mouseIsDown:Boolean = false;	//is the mouse down?
	private var currX:Number;					//current touchscreen location
	private var currY:Number;					//current touchscreen location
	
	
	private function TouchscreenEmulator (_r:MovieClip) {
		root = _r;
		Mouse.addListener(this);
		root.tsBox._visible = false;
	}
	
	public static function getInst (_r:MovieClip) {
		if (TouchscreenEmulator.inst) { return(TouchscreenEmulator.inst); }
		else { return(new TouchscreenEmulator(_r)); }
	}
	
	public function onMouseDown () :Void {
		mouseIsDown = true;
		root.tsBox._visible = true;
		onMouseMove();
	}
	
	public function onMouseUp () :Void {
		mouseIsDown = false;
		root.tsBox._visible = false;
	}
	
	public function onMouseMove () :Void {
		if (!mouseIsDown) { return; }
		
		var tx:Number = Math.floor(root._xmouse / RES_X);
		var ty:Number = Math.floor(root._ymouse / RES_Y);
		
		if (tx != currX) {
			currX = tx;
			root.tsBox._x = RES_X * currX;
		}
		if (ty != currY) {
			currY = ty;
			root.tsBox._y = RES_Y * currY;
		}
	}
}