﻿class Wall extends MovieClip {
	private static var instances:Array = new Array();
	public static var POS_LEFT = 0;
	public static var POS_RIGHT = 1;
	public static var POS_TOP = 2;
	public static var POS_BOTTOM = 3;
	private var MAX_NUM_HITS = 3;
	private var numHits;
	private var isVert:Boolean;
	private var plr:Player;
	private var isAlive:Boolean;
	private var position:Number;
	private static function addInstance(inst:Wall):Void {
		instances.push(inst);
	}
	public static function testCollision(obj:Ball):Boolean {
		for (var w in instances) {
			if (instances[w].testColl(obj)) {
				return true;
			}
		}
		return false;
	}
	public function Wall() {
		this.numHits = 0;
		this.isAlive = true;
		Wall.addInstance(this);
		if (this._rotation == 90 || this._rotation == 270) {
			isVert = false;
		} else {
			isVert = true;
		}
	}
	public function init(pl:Player, pos:Number) {
		this.plr = pl;
		pl.addWall(this);
		this.position = pos;
	}
	public function testColl(targ:Ball):Boolean {
		if (!isAlive) {
			return false;
		}
		if (!hitTest(targ.getTestBall())) {
			return false;
		}
		//trace ("wall hit! rotation="+this._rotation);
		numHits++;
		this.gotoAndStop("hit"+numHits);
		this.plr.gotHit();
		if (numHits>=MAX_NUM_HITS) {
			this.plr.removeWall(this);
			this.isAlive = false;
			return true;
		}
		if (numHits<MAX_NUM_HITS) {
			var randSpeed = Math.random(2)-1;
			//var randSpeed = 0;
			switch (this.position) {
			case POS_BOTTOM :
				targ.reflectUp(randSpeed);
				break;
			case POS_RIGHT :
				targ.reflectLeft(randSpeed);
				break;
			case POS_TOP :
				targ.reflectDown(randSpeed);
				break;
			case POS_LEFT :
				targ.reflectRight(randSpeed);
				break;
			default :
				trace("Incorrect position: "+this._rotation);
			}
			return true;
		}
		return true;
	}
}
